#include "inputspec.h"
#include "piece.h"
#include <iostream>

using namespace std;



// Create an InputSpec by reading the specification from standard in.

InputSpec::InputSpec()
{
    // read input spec
    
    cin >> boxWidth >> boxHeight;
    
    for (int j = 0; j < MAXBOXDIM; ++j)
        for (int i = 0; i < MAXBOXDIM; ++i)
            if (j < boxHeight && i < boxWidth)
                cin >> boxShape[i][j];
            else
                boxShape[i][j] = true;

    char c;                     // for reading '-' separator char
    
    cin >> c;
    
    cin >> numShapes;
    
    goalIndex = numShapes;
    ++numShapes;                // for the goal piece shape     
    
    shapes = new PieceShape[numShapes];     // allocate space for the piece shapes
    
    // read the piece shapes
    
    int width, height;
    
    for (int n = 0; n < numShapes - 1; ++n)
    {
        cin >> width >> height;
        
        for (int j = 0; j < MAXPIECEDIM; ++j)
            for (int i = 0; i < MAXPIECEDIM; ++i)
                if (j < height && i < width)
                    cin >> shapes[n][i][j];
                else
                    shapes[n][i][j] = false;
    }
        
    cin >> c;                   // '-' separator
    
    // read the goal piece shape
    
    cin >> width >> height;
    
    for (int j = 0; j < MAXPIECEDIM; ++j)
        for (int i = 0; i < MAXPIECEDIM; ++i)
            if (j < height && i < width)
                cin >> shapes[goalIndex][i][j];
            else
                shapes[goalIndex][i][j] = false;
        
    cin >> c;                   // '-' separator
    
    // read the goal location
    
    cin >> goalX >> goalY;  
}
